Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright 2012-04-26 Werner Randelshofer
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.monte.media.io
Class StreamPosTokenizer

    java.lang.Object
      org.monte.media.io.StreamPosTokenizer

    public class StreamPosTokenizer

extends java.lang.Object

This extension of `StreamTokenizer` keeps track of the position of the tokens in the input stream, and it can parse hexadecimal numbers and double numbers with exponents.

The handling of numeric data is also different: a single dot '.' and minus dot '-.' are not treated as numbers.

Version:
  $Id: StreamPosTokenizer.java 134 2011-12-02 16:23:00Z werner $
Author:
  Werner Randelshofer, Hausmatt 10, Immensee, CH-6405, Switzerland

Field Summary
`double` | `nval` If the current token is a number, this field contains the value of that number.
`java.lang.String` | `sval` If the current token is a word token, this field contains a string giving the characters of the word token.
`static int` | `TT_EOF` A constant indicating that the end of the stream has been read.
`static int` | `TT_EOL` A constant indicating that the end of the line has been read.
`static int` | `TT_NUMBER` A constant indicating that a number token has been read.
`static int` | `TT_WORD` A constant indicating that a word token has been read.
`int` | `ttype` After a call to the `nextToken` method, this field contains the type of the token just read.

Constructor Summary
`StreamPosTokenizer()` Initializes everything except the streams.
`StreamPosTokenizer(java.io.Reader r)` Create a tokenizer that parses the given character stream.

Method Summary
`void` | `commentChar(int ch)` Specified that the character argument starts a single-line comment.
`void` | `consumeGreedy(java.lang.String greedyToken)` Consumes a substring from the current sval of the StreamPosTokenizer.
`void` | `eolIsSignificant(boolean flag)` Determines whether or not ends of line are treated as tokens.
`int` | `getEndPosition()` Returns the end position of the token relative to the position that the stream had, when the StreamPosTokenizer was constructed.
`int` | `getStartPosition()` Returns the start position of the token relative to the position that the stream had, when the StreamPosTokenizer was constructed.
`int` | `lineno()` Return the current line number.
`void` | `lowerCaseMode(boolean fl)` Determines whether or not word token are automatically lowercased.
`int` | `nextChar()` Reads the next character from the input stream, without passing it to the tokenizer.
`int` | `nextToken()` Parses the next token from the input stream of this tokenizer.
`void` | `ordinaryChar(int ch)` Specifies that the character argument is "ordinary" in this tokenizer.
`void` | `ordinaryChars(int low, int hi)` Specifies that all characters c in the range `low <= c <= high` are "ordinary" in this tokenizer.
`void` | `parseExponents()` Enables number parsing of exponents.
`void` | `parseHexNumbers()` Enables number parsing for decimal numbers and for hexadecimal numbers
`void` | `parseNumbers()` Specifies that numbers should be parsed by this tokenizer.
`void` | `parsePlusAsNumber()`
`void` | `pushBack()` Causes the next call to the `nextToken` method of this tokenizer to return the current value in the `ttype` field, and not to modify the value in the `nval` or `sval` field.
`void` | `pushCharBack(int ch)` Unreads a character back into the input stream of the tokenizer.
`void` | `quoteChar(int ch)` Specifies that matching pairs of this character delimit string constants in this tokenizer.
`void` | `resetSyntax()` Resets this tokenizer's syntax table so that all characters are "ordinary." See the `ordinaryChar` method for more information on a character being ordinary.
`void` | `setReader(java.io.Reader r)` Sets the reader for the tokenizer.
`void` | `setSlashSlashToken(java.lang.String slashSlash)` Sets the slash slash token.
`void` | `setSlashStarTokens(java.lang.String slashStar, java.lang.String starSlash)` Sets the slash star and star slash tokens.
`void` | `setStartPosition(int p)` Set the start position of the current token.
`void` | `slashSlashComments(boolean flag)` Determines whether or not the tokenizer recognizes C++-style comments.
`void` | `slashStarComments(boolean flag)` Determines whether or not the tokenizer recognizes C-style comments.
`java.lang.String` | `toString()` Returns the string representation of the current stream token.
`void` | `whitespaceChars(int low, int hi)` Specifies that all characters c in the range `low <= c <= high` are white space characters.
`void` | `wordChars(int low, int hi)` Specifies that all characters c in the range `low <= c <= high` are word constituents.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### ttype

    public int ttype

  After a call to the `nextToken` method, this field contains the type of the token just read. For a single character token, its value is the single character, converted to an integer. For a quoted string token (see , its value is the quote character. Otherwise, its value is one of the following:
  - `TT_WORD` indicates that the token is a word.
  - `TT_NUMBER` indicates that the token is a number.
  - `TT_EOL` indicates that the end of line has been read. The field can only have this value if the `eolIsSignificant` method has been called with the argument `true`.
  - `TT_EOF` indicates that the end of the input stream has been reached.

  See Also:
    `StreamTokenizer.eolIsSignificant(boolean)`, `StreamTokenizer.nextToken()`, `StreamTokenizer.quoteChar(int)`, `StreamTokenizer.TT_EOF`, `StreamTokenizer.TT_EOL`, `StreamTokenizer.TT_NUMBER`, `StreamTokenizer.TT_WORD`

### TT_EOF

    public static final int TT_EOF

  A constant indicating that the end of the stream has been read.

  See Also:
    Constant Field Values

### TT_EOL

    public static final int TT_EOL

  A constant indicating that the end of the line has been read.

  See Also:
    Constant Field Values

### TT_NUMBER

    public static final int TT_NUMBER

  A constant indicating that a number token has been read.

  See Also:
    Constant Field Values

### TT_WORD

    public static final int TT_WORD

  A constant indicating that a word token has been read.

  See Also:
    Constant Field Values

### sval

    public java.lang.String sval

  If the current token is a word token, this field contains a string giving the characters of the word token. When the current token is a quoted string token, this field contains the body of the string.

  The current token is a word when the value of the `ttype` field is `TT_WORD`. The current token is a quoted string token when the value of the `ttype` field is a quote character.

  See Also:
    `StreamTokenizer.quoteChar(int)`, `StreamTokenizer.TT_WORD`, `StreamTokenizer.ttype`

### nval

    public double nval

  If the current token is a number, this field contains the value of that number. The current token is a number when the value of the `ttype` field is `TT_NUMBER`.

  See Also:
    `StreamTokenizer.TT_NUMBER`, `StreamTokenizer.ttype`

Constructor Detail

### StreamPosTokenizer

    public StreamPosTokenizer()

  Initializes everything except the streams.

### StreamPosTokenizer

    public StreamPosTokenizer(java.io.Reader r)

  Create a tokenizer that parses the given character stream.

  Since:
    JDK1.1

Method Detail

### setReader

    public void setReader(java.io.Reader r)

  Sets the reader for the tokenizer.

  Parameters:
    `r` -

### resetSyntax

    public void resetSyntax()

  Resets this tokenizer's syntax table so that all characters are "ordinary." See the `ordinaryChar` method for more information on a character being ordinary.

  See Also:
    `StreamTokenizer.ordinaryChar(int)`

### wordChars

    public void wordChars(int low,
                          int hi)

  Specifies that all characters c in the range `low <= c <= high` are word constituents. A word token consists of a word constituent followed by zero or more word constituents or number constituents.

  Parameters:
    `low` - the low end of the range.
    `hi` - the high end of the range.

### whitespaceChars

    public void whitespaceChars(int low,
                                int hi)

  Specifies that all characters c in the range `low <= c <= high` are white space characters. White space characters serve only to separate tokens in the input stream.

  Parameters:
    `low` - the low end of the range.
    `hi` - the high end of the range.

### ordinaryChars

    public void ordinaryChars(int low,
                              int hi)

  Specifies that all characters c in the range `low <= c <= high` are "ordinary" in this tokenizer. See the `ordinaryChar` method for more information on a character being ordinary.

  Parameters:
    `low` - the low end of the range.
    `hi` - the high end of the range.
  See Also:
    `StreamTokenizer.ordinaryChar(int)`

### ordinaryChar

    public void ordinaryChar(int ch)

  Specifies that the character argument is "ordinary" in this tokenizer. It removes any special significance the character has as a comment character, word component, string delimiter, white space, or number character. When such a character is encountered by the parser, the parser treates it as a single-character token and sets `ttype` field to the character value.

  Parameters:
    `ch` - the character.
  See Also:
    `StreamTokenizer.ttype`

### commentChar

    public void commentChar(int ch)

  Specified that the character argument starts a single-line comment. All characters from the comment character to the end of the line are ignored by this stream tokenizer.

  Parameters:
    `ch` - the character.

### quoteChar

    public void quoteChar(int ch)

  Specifies that matching pairs of this character delimit string constants in this tokenizer.

  When the `nextToken` method encounters a string constant, the `ttype` field is set to the string delimiter and the `sval` field is set to the body of the string.

  If a string quote character is encountered, then a string is recognized, consisting of all characters after (but not including) the string quote character, up to (but not including) the next occurrence of that same string quote character, or a line terminator, or end of file. The usual escape sequences such as `"\n"` and `"\t"` are recognized and converted to single characters as the string is parsed.

  Parameters:
    `ch` - the character.
  See Also:
    `StreamTokenizer.nextToken()`, `StreamTokenizer.sval`, `StreamTokenizer.ttype`

### parseNumbers

    public void parseNumbers()

  Specifies that numbers should be parsed by this tokenizer. The syntax table of this tokenizer is modified so that each of the twelve characters:

  >           0 1 2 3 4 5 6 7 8 9 . -

  has the "numeric" attribute.

  When the parser encounters a word token that has the format of a double precision floating-point number, it treats the token as a number rather than a word, by setting the the `ttype` field to the value `TT_NUMBER` and putting the numeric value of the token into the `nval` field.

  See Also:
    `StreamTokenizer.nval`, `StreamTokenizer.TT_NUMBER`, `StreamTokenizer.ttype`

### parsePlusAsNumber

    public void parsePlusAsNumber()

### parseHexNumbers

    public void parseHexNumbers()

  Enables number parsing for decimal numbers and for hexadecimal numbers

### parseExponents

    public void parseExponents()

  Enables number parsing of exponents. Exponents appear after the last digit of number with capital letter 'E' or small letter 'e'.

### eolIsSignificant

    public void eolIsSignificant(boolean flag)

  Determines whether or not ends of line are treated as tokens. If the flag argument is true, this tokenizer treats end of lines as tokens; the `nextToken` method returns `TT_EOL` and also sets the `ttype` field to this value when an end of line is read.

  A line is a sequence of characters ending with either a carriage-return character (`'\r'`) or a newline character (`'\n'`). In addition, a carriage-return character followed immediately by a newline character is treated as a single end-of-line token.

  If the `flag` is false, end-of-line characters are treated as white space and serve only to separate tokens.

  Parameters:
    `flag` - `true` indicates that end-of-line characters are separate tokens; `false` indicates that end-of-line characters are white space.
  See Also:
    `StreamTokenizer.nextToken()`, `StreamTokenizer.ttype`, `StreamTokenizer.TT_EOL`

### slashStarComments

    public void slashStarComments(boolean flag)

  Determines whether or not the tokenizer recognizes C-style comments. If the flag argument is `true`, this stream tokenizer recognizes C-style comments. All text between successive occurrences of `/*` and `*/` are discarded.

  If the flag argument is `false`, then C-style comments are not treated specially.

  Parameters:
    `flag` - `true` indicates to recognize and ignore C-style comments.

### slashSlashComments

    public void slashSlashComments(boolean flag)

  Determines whether or not the tokenizer recognizes C++-style comments. If the flag argument is `true`, this stream tokenizer recognizes C++-style comments. Any occurrence of two consecutive slash characters (`'/'`) is treated as the beginning of a comment that extends to the end of the line.

  If the flag argument is `false`, then C++-style comments are not treated specially.

  Parameters:
    `flag` - `true` indicates to recognize and ignore C++-style comments.

### lowerCaseMode

    public void lowerCaseMode(boolean fl)

  Determines whether or not word token are automatically lowercased. If the flag argument is `true`, then the value in the `sval` field is lowercased whenever a word token is returned (the `ttype` field has the value `TT_WORD` by the `nextToken` method of this tokenizer.

  If the flag argument is `false`, then the `sval` field is not modified.

  Parameters:
    `fl` - `true` indicates that all word tokens should be lowercased.
  See Also:
    `StreamTokenizer.nextToken()`, `StreamTokenizer.ttype`, `StreamTokenizer.TT_WORD`

### nextToken

    public int nextToken()
                  throws java.io.IOException

  Parses the next token from the input stream of this tokenizer. The type of the next token is returned in the `ttype` field. Additional information about the token may be in the `nval` field or the `sval` field of this tokenizer.

  Typical clients of this class first set up the syntax tables and then sit in a loop calling nextToken to parse successive tokens until TT_EOF is returned.

  Returns:
    the value of the `ttype` field.
  Throws:
    `java.io.IOException` - if an I/O error occurs.
  See Also:
    `StreamTokenizer.nval`, `StreamTokenizer.sval`, `StreamTokenizer.ttype`

### nextChar

    public int nextChar()
                 throws java.io.IOException

  Reads the next character from the input stream, without passing it to the tokenizer.

  Throws:
    `java.io.IOException`

### pushCharBack

    public void pushCharBack(int ch)
                      throws java.io.IOException

  Unreads a character back into the input stream of the tokenizer.

  Throws:
    `java.io.IOException`

### setSlashStarTokens

    public void setSlashStarTokens(java.lang.String slashStar,
                                   java.lang.String starSlash)

  Sets the slash star and star slash tokens. Due to limitations by this implementation, both tokens must have the same number of characters and the character length must be either 1 or 2.

### setSlashSlashToken

    public void setSlashSlashToken(java.lang.String slashSlash)

  Sets the slash slash token. Due to limitations by this implementation, the character length must be either 1 or 2.

### pushBack

    public void pushBack()

  Causes the next call to the `nextToken` method of this tokenizer to return the current value in the `ttype` field, and not to modify the value in the `nval` or `sval` field.

  See Also:
    `StreamTokenizer.nextToken()`, `StreamTokenizer.nval`, `StreamTokenizer.sval`, `StreamTokenizer.ttype`

### lineno

    public int lineno()

  Return the current line number.

  Returns:
    the current line number of this stream tokenizer.

### getStartPosition

    public int getStartPosition()

  Returns the start position of the token relative to the position that the stream had, when the StreamPosTokenizer was constructed.

  Returns:
    the start position of the token.

### setStartPosition

    public void setStartPosition(int p)

  Set the start position of the current token.

### getEndPosition

    public int getEndPosition()

  Returns the end position of the token relative to the position that the stream had, when the StreamPosTokenizer was constructed.

  Returns:
    the end position of the token.

### consumeGreedy

    public void consumeGreedy(java.lang.String greedyToken)

  Consumes a substring from the current sval of the StreamPosTokenizer.

### toString

    public java.lang.String toString()

  Returns the string representation of the current stream token.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a string representation of the token specified by the `ttype`, `nval`, and `sval` fields.
  See Also:
    `StreamTokenizer.nval`, `StreamTokenizer.sval`, `StreamTokenizer.ttype`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright 2012-04-26 Werner Randelshofer
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD